"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _stringify = _interopRequireDefault(require("@babel/runtime/core-js/json/stringify"));

var _assert = require("assert");

var _babelTemplate = _interopRequireDefault(require("babel-template"));

var fromSourceString = function fromSourceString(code) {
  return (0, _babelTemplate.default)("(".concat(code, ")"))().expression;
};

var _default = function _default(_ref) {
  var _ref$types = _ref.types,
      callExpression = _ref$types.callExpression,
      identifier = _ref$types.identifier,
      importDeclaration = _ref$types.importDeclaration,
      importSpecifier = _ref$types.importSpecifier,
      memberExpression = _ref$types.memberExpression,
      stringLiteral = _ref$types.stringLiteral,
      variableDeclaration = _ref$types.variableDeclaration,
      variableDeclarator = _ref$types.variableDeclarator,
      isImportDeclaration = _ref$types.isImportDeclaration,
      isImportDefaultSpecifier = _ref$types.isImportDefaultSpecifier,
      isImportNamespaceSpecifier = _ref$types.isImportNamespaceSpecifier,
      isImportSpecifier = _ref$types.isImportSpecifier,
      isStringLiteral = _ref$types.isStringLiteral,
      assertImportDefaultSpecifier = _ref$types.assertImportDefaultSpecifier;

  var readFileSyncCallExpressionArgs = function readFileSyncCallExpressionArgs(value, options) {
    // [require.resolve(<file>)[, encoding|options]]
    var args = [callExpression(memberExpression(identifier('require'), identifier('resolve')), [stringLiteral(value)])];

    if (options) {
      // Second argument to readFileSync can be string or object
      args.push(fromSourceString((0, _stringify.default)(options)));
    }

    return args;
  };

  var testOptions = function testOptions(opts, value, match) {
    var _opts$options = opts.options,
        options = _opts$options === void 0 ? [] : _opts$options,
        test = opts.test;
    var optsArray = test ? [opts] : options;
    optsArray.some(function (_ref2) {
      var options = _ref2.options,
          test = _ref2.test;

      if (test && new RegExp(test).test(value)) {
        return match(readFileSyncCallExpressionArgs(value, options));
      }
    });
  };

  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(path, _ref3) {
        var opts = _ref3.opts;
        var _path$node = path.node,
            specifiers = _path$node.specifiers,
            value = _path$node.source.value;
        testOptions(opts, value, function (readFileSyncArgs) {
          (0, _assert.equal)(specifiers.length, 1, 'Number of import specifiers.');
          assertImportDefaultSpecifier(specifiers[0]);
          var local = specifiers[0].local; // Search import <specifiers> 'fs';

          var readFileSync;
          var fsImportDeclarations = path.parent.body.filter(isImportDeclaration).filter(function (_ref4) {
            var value = _ref4.source.value;
            return value === 'fs';
          });

          if (!fsImportDeclarations.some(function (_ref5) {
            var specifiers = _ref5.specifiers;
            return specifiers.find(function (specifier) {
              if (isImportDefaultSpecifier(specifier) || isImportNamespaceSpecifier(specifier)) {
                readFileSync = memberExpression(specifier.local, identifier('readFileSync'));
                return true;
              }

              if (isImportSpecifier(specifier)) {
                if (specifier.imported.name === 'readFileSync') {
                  readFileSync = (0, _objectSpread2.default)({}, specifier.local);
                  return true;
                }
              }
            });
          })) {
            // fs is not imported
            readFileSync = path.scope.generateUidIdentifier('readFileSync'); // Add import { readFileSync as _readFileSync } from 'fs';

            path.insertBefore(importDeclaration([importSpecifier(readFileSync, identifier('readFileSync'))], stringLiteral('fs')));
          } // const <localName> = <readFileSync>(<args>);


          path.replaceWith(variableDeclaration('const', [variableDeclarator(local, callExpression(readFileSync, readFileSyncArgs))]));
          return true;
        });
      },
      CallExpression: function CallExpression(path, _ref6) {
        var opts = _ref6.opts;

        if (path.node.callee.name === 'require') {
          var args = path.node.arguments;

          if (args.length) {
            var arg = args[0];

            if (isStringLiteral(arg)) {
              testOptions(opts, arg.value, function (readFileSyncArgs) {
                // require('fs').readFileSync(<args>)
                path.replaceWith(callExpression(memberExpression(callExpression(identifier('require'), [stringLiteral('fs')]), identifier('readFileSync')), readFileSyncArgs));
                return true;
              });
            }
          }
        }
      }
    }
  };
};

exports.default = _default;
//# sourceMappingURL=index.js.map